var debug_box = null

function dlog(msg) {
	if (!debug_box) {
		debug_box = document.createElement("div");
		debug_box.setAttribute("style",
			"background-color: white; " + 
			"font-family: monospace; " + 
			"font-size:9pt; " + 
			"border: solid black 1px; background:yellow;" + 
			"position: fixed; top:300px;left:0px;width:400px;z-index:100;"+ 
			"padding: 10px;");
		document.body.appendChild(debug_box);
		debug_box.innerHTML = "<p style='text-align:left;background:#fff;' onclick='clearDebug()'>Debug Info - click here to clear</p>";
	}
	
	debug_box.style.display = 'block';
	var p = document.createElement("p");
	p.appendChild(document.createTextNode(msg));
	debug_box.appendChild(p);
	
	if ( bridge_is_available() )
		Bridge.log("JAVASCRIPT DEBUG: "+msg)
}

function clearDebug()
{
	debug_box.innerHTML = "<p style='text-align:left;background:#fff;' onclick='clearDebug()'>Debug Info - click here to clear</p>";
	debug_box.style.display = 'none';
	debug_box = null
}

//recursive function to display the whole subtree of a node
//tabs = level of recursion = level of the tree
function debug_node(nodeObject,tabs)
{
	//special case to avoid runtime error below
	if ( nodeObject == undefined ) {
		dlog ( tabs + "undefined" );
		return;
	}
	
	//node info
	dlog ( tabs + "Object:" + nodeObject );
	dlog ( tabs + "Value: " + nodeObject.nodeValue );
	dlog ( tabs + "Type:  " + nodeObject.nodeType );
	dlog ( tabs + "Name:  " + nodeObject.nodeName );
	dlog ( tabs + "Class: " + nodeObject.className );
	dlog ( tabs + "Id:    " + nodeObject.id );
	
	//no children
	if ( nodeObject.childNodes == undefined ) {
		dlog ( tabs + "Children: ---" );
		return;
	}
	
	//some children
	var countChildren = nodeObject.childNodes.length;
	dlog ( tabs + "Children (" + countChildren + "):" );
	var newtabs = "---" + tabs;
	var i;
	for (i=0; i<countChildren; i++){
		var aChild = nodeObject.childNodes[i];
		dlog ( newtabs + i );
		debug_node ( aChild, newtabs );
	}
}
